#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

//!    (3 )!

//  Input   
	struct Input {
        vector<double> Numbers;
        size_t bin_count{};
    };

// 
Input input_data(){
    size_t number_count;
    Input stct;
    //   
    cerr << "Enter number count ";
	cin >> number_count;
    // 
	vector<double> Numbers(number_count);
	stct.Numbers.resize(number_count);
	cerr << "Enter array:\n";
	cin >> Numbers[0];
	for (int i = 1; i < number_count; i++) {
		cin >> stct.Numbers[i];
	}
	//  
	cerr << "Enter bin count\n";
	cin >> stct.bin_count;
	// 
	return stct;
}

//    
void find_minmax(const vector<double>& numbers, double& Min, double& Max){
    Min = numbers[0];
    Max = numbers[0];
    for (int i = 1; i < numbers.size(); i++) {
		if (numbers[i] > Max)
			Max = numbers[i];
		if (numbers[i] < Min)
			Min = numbers[i];
	}

}

//  
vector<size_t> make_histogram(const vector<double>& Numbers, size_t bin_count){
    //   
    double Max, Min;
    find_minmax(Numbers, Min, Max);
	double bin_size = (Max-Min) / bin_count;
	// 
	vector<size_t> bins(bin_count);
	for (size_t i = 0; i < bin_count; i++) //  
		bins[i] = 0;
	for (size_t i = 0; i < bin_count; i++) {
		double lo = Min + i * bin_size;
		double hi = Min + (i + 1) * bin_size;
		for (size_t j = 0; j < Numbers.size(); j++) {
			if (lo <= Numbers[j] && Numbers[j] <= hi)
				bins[i]++;
		}
	}
	return bins;
}

//    
void show_histogram_text(const vector<size_t>& bins){
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 3;

    //  
	size_t max4scale = 0;
	for (size_t x : bins){
        if (x > max4scale){
            max4scale = x;
        }
	}
	if (max4scale > MAX_ASTERISK){
        for (size_t x : bins) {
            if (x >= 100){
                cout  << x << " | ";
            }
            else if (x >= 10){
                cout << " " << x << " | ";
            }
            else{
                cout << "  " << x << " | ";
            }
            size_t count = x;
            size_t height = MAX_ASTERISK * (static_cast<double>(count) / max4scale);
            for (size_t i = 0; i < height; i++) {
                cout << "*";
            }
            cout << "\n";
        }
	}
	else{
	//
	for (size_t x : bins) {
	    if (x >= 100){
            cout  << x << " | ";
	    }
	    else if (x >= 10){
            cout << " " << x << " | ";
	    }
	    else{
            cout << "  " << x << " | ";
	    }
		for (size_t i = 0; i < x; i++) {
			cout << "*";
		}
		cout << "\n";
    }
	}
	return;
}

int main() {
	//    
	Input in = input_data();

	//   
	double max, min;
	find_minmax(in.Numbers, min, max);

	//  bins  
	vector<size_t> bins = make_histogram(in.Numbers, in.bin_count);

	// 
	show_histogram_text(bins);

	return 0;
}
